find out about plnode-utils and the python requirement
[build.git] / vbuild-init-lxc.sh
1 #!/bin/bash
2 # -*-shell-*-
3
4 #shopt -s huponexit
5
6 COMMAND=$(basename $0)
7 DIRNAME=$(dirname $0)
8 BUILD_DIR=$(pwd)
9
10 # pkgs parsing utilities
11 PATH=$(dirname $0):$PATH export PATH
12 . build.common
13
14 DEFAULT_FCDISTRO=f16
15 DEFAULT_PLDISTRO=planetlab
16 DEFAULT_PERSONALITY=linux64
17 DEFAULT_IFNAME=eth0
18
19 COMMAND_VBUILD="vbuild-init-lxc.sh"
20 COMMAND_MYPLC="vtest-init-lxc.sh"
21
22 lxc_version="lxc-0.8.0"
23 lxc_git_repo="git://lxc.git.sourceforge.net/gitroot/lxc/lxc"
24
25 function bridge_init () {
26
27     # turn on verbosity
28     set -x
29
30     # constant
31     INTERFACE_BRIDGE=br0
32
33     # Default Value for INTERFACE_LAN
34     INTERFACE_LAN=$(netstat -rn | grep '^0.0.0.0' | awk '{print $8;}')
35
36
37     echo "========== $COMMAND: entering start - beg"
38     hostname
39     uname -a
40     ifconfig
41     netstat -rn
42     echo "========== $COMMAND: entering start - end"
43
44     # disable netfilter calls for bridge interface (they cause panick on 2.6.35 anyway)
45     #
46     # another option would be to accept the all forward packages for
47     # bridged interface like: -A FORWARD -m physdev --physdev-is-bridged -j ACCEPT
48     sysctl net.bridge.bridge-nf-call-iptables=0
49     sysctl net.bridge.bridge-nf-call-ip6tables=0
50     sysctl net.bridge.bridge-nf-call-arptables=0
51
52     # take extra arg for ifname, if provided
53     [ -n "$1" ] && { INTERFACE_LAN=$1; shift ; }
54
55     #if we have already configured the same host_box no need to do it again
56     /sbin/ifconfig $INTERFACE_BRIDGE &> /dev/null && {
57         echo "Bridge interface $INTERFACE_BRIDGE already set up - $COMMAND start exiting"
58         return 0
59     }
60     /sbin/ifconfig $INTERFACE_LAN &>/dev/null || {
61         echo "Cannot use interface $INTERFACE_LAN - exiting"
62         exit 1
63     }
64
65     
66     #Getting host IP/masklen
67     address=$(/sbin/ip addr show $INTERFACE_LAN | grep -v inet6 | grep inet | head --lines=1 | awk '{print $2;}')
68     [ -z "$address" ] && { echo "ERROR: Could not determine IP address for $INTERFACE_LAN" ; exit 1 ; }
69
70 broadcast=$(/sbin/ip addr show $INTERFACE_LAN | grep -v inet6 | grep inet | head --lines=1 | awk '{print $4;}')
71     [ -z "$broadcast" ] && echo "WARNING: Could not determine broadcast address for $INTERFACE_LAN"
72
73     gateway=$(netstat -rn | grep '^0.0.0.0' | awk '{print $2;}')
74     [ -z "$gateway" ] && echo "WARNING: Could not determine gateway IP"
75
76     # creating the bridge
77     echo "Creating bridge INTERFACE_BRIDGE=$INTERFACE_BRIDGE"
78     brctl addbr $INTERFACE_BRIDGE
79     #brctl stp $INTERFACE_BRIDGE yes
80     brctl addif $INTERFACE_BRIDGE $INTERFACE_LAN
81     echo "Activating promiscuous mode INTERFACE_LAN=$INTERFACE_LAN"
82     /sbin/ifconfig $INTERFACE_LAN 0.0.0.0 promisc up
83     sleep 2
84     echo "Setting bridge address=$address broadcast=$broadcast"
85     # static
86     #/sbin/ifconfig $INTERFACE_BRIDGE $address broadcast $broadcast up
87     dhclient $INTERFACE_BRIDGE
88     sleep 1
89
90     #Reconfigure the routing table
91     echo "Configuring gateway=$gateway"
92     route add default gw $gateway
93
94     echo "========== $COMMAND: exiting start - beg"
95     ifconfig
96     netstat -rn
97     echo "========== $COMMAND: exiting start - end"
98
99
100 return 0
101
102 }
103
104
105 function failure () {
106     echo "$COMMAND : Bailing out"
107     exit 1
108 }
109
110 function cidr_notation () {
111
112 netmask=$1; shift
113 cidr=0
114 for i in $(seq 1 4) ; do
115     part=$(echo $netmask | cut -d. -f $i)
116     case $part in
117         "255") cidr=$((cidr + 8));;
118         "254") cidr=$((cidr + 7));;
119         "252") cidr=$((cidr + 6));;
120         "248") cidr=$((cidr + 5));;
121         "240") cidr=$((cidr + 4));;
122         "224") cidr=$((cidr + 3));;
123         "192") cidr=$((cidr + 2));;
124         "128") cidr=$((cidr + 1));;
125         "0") cidr=$((cidr + 0));;
126      esac
127 done
128 echo $cidr
129
130 }
131
132 function check_yum_installed () {
133     package=$1; shift
134     rpm -q $package >& /dev/null || yum -y install $package
135 }
136
137 function check_yumgroup_installed () {
138     group="$1"; shift
139     yum grouplist "$group" | grep -q Installed || { yum -y groupinstall "$group" ; }
140 }
141
142 function prepare_host() {
143         
144     #################### lxc-tools : rebuild as current fedora release has flaws
145     #install development tools
146     check_yumgroup_installed "Development Tools"
147     #install libcap-devel, libvirt
148     check_yum_installed libcap-devel
149     check_yum_installed libvirt
150
151     #retrieve and install lxc from sources 
152     raw_version=$(lxc-version ||: )
153     lxc_installed_version=$(echo $raw_version | sed -e 's,.*: ,,')
154     if [ "$lxc_installed_version" != "$lxc_version" ] ; then
155         echo "Expecting version" '['$lxc_version']'
156         echo "Found version" '['$lxc_installed_version']'
157         echo "Installing lxc ..."
158         cd /root
159         [ -d lxc ] || git clone "$lxc_git_repo"
160         cd lxc
161         git pull
162         git checkout $lxc_version
163         ./autogen.sh
164         ./configure --prefix=/usr --exec-prefix=/usr
165         make
166         make install
167         mkdir -p /usr/var/lib/
168         [ -d /usr/var/lib/lxc ] || ln -s /var/lib/lxc /usr/var/lib/lxc
169         cd $BUILD_DIR
170     fi
171  
172 #    #create a placeholder (just a hack to make lxc works)
173 #    [ -d "/usr/local/var/lib" ] || mkdir -p /usr/local/var/lib
174
175     #################### bride initialization
176     check_yum_installed bridge-utils
177     #Bridge init
178     isInstalled=$(netstat -rn | grep '^0.0.0.0' | awk '{print $8;}')
179     if [ "$isInstalled" != "br0" ] ; then
180         bridge_init
181         sleep 5
182     fi
183
184     return 0
185 }
186
187
188
189 function configure_fedora() {
190
191     # disable selinux in fedora
192     mkdir -p $rootfs_path/selinux
193     echo 0 > $rootfs_path/selinux/enforce
194
195    # configure the network 
196
197     cat <<EOF > ${rootfs_path}/etc/sysconfig/network-scripts/ifcfg-$IFNAME
198 DEVICE=$IFNAME
199 BOOTPROTO=static
200 ONBOOT=yes
201 HOSTNAME=$HOSTNAME
202 IPADDR=$IP
203 NETMASK=$NETMASK
204 GATEWAY=$GATEWAY
205 NM_CONTROLLED=no
206 TYPE=Ethernet
207 MTU=1500
208 EOF
209
210 # set the hostname
211     cat <<EOF > ${rootfs_path}/etc/sysconfig/network
212 NETWORKING=yes
213 HOSTNAME=$HOSTNAME
214 EOF
215
216     # set minimal hosts
217 #    cat <<EOF > $rootfs_path/etc/hosts
218 #127.0.0.1 localhost $HOSTNAME
219 #EOF
220
221     dev_path="${rootfs_path}/dev"
222     rm -rf $dev_path
223     mkdir -p $dev_path
224     mknod -m 666 ${dev_path}/null c 1 3
225     mknod -m 666 ${dev_path}/zero c 1 5
226     mknod -m 666 ${dev_path}/random c 1 8
227     mknod -m 666 ${dev_path}/urandom c 1 9
228     mkdir -m 755 ${dev_path}/pts
229     mkdir -m 1777 ${dev_path}/shm
230     mknod -m 666 ${dev_path}/tty c 5 0
231     mknod -m 666 ${dev_path}/tty0 c 4 0
232     mknod -m 666 ${dev_path}/tty1 c 4 1
233     mknod -m 666 ${dev_path}/tty2 c 4 2
234     mknod -m 666 ${dev_path}/tty3 c 4 3
235     mknod -m 666 ${dev_path}/tty4 c 4 4
236     mknod -m 600 ${dev_path}/console c 5 1
237     mknod -m 666 ${dev_path}/full c 1 7
238     mknod -m 600 ${dev_path}/initctl p
239     mknod -m 666 ${dev_path}/ptmx c 5 2
240
241     #echo "setting root passwd to $root_password"
242     #echo "root:$root_password" | chroot $rootfs_path chpasswd
243
244     return 0
245 }
246
247
248 function configure_fedora_init() {
249
250     sed -i 's|.sbin.start_udev||' ${rootfs_path}/etc/rc.sysinit
251     sed -i 's|.sbin.start_udev||' ${rootfs_path}/etc/rc.d/rc.sysinit
252     chroot ${rootfs_path} chkconfig udev-post off
253     chroot ${rootfs_path} chkconfig network on
254 }
255
256
257 function configure_fedora_systemd() {
258
259     unlink ${rootfs_path}/etc/systemd/system/default.target
260     touch ${rootfs_path}/etc/fstab
261     chroot ${rootfs_path} ln -s /dev/null //etc/systemd/system/udev.service
262     chroot ${rootfs_path} ln -s /lib/systemd/system/multi-user.target /etc/systemd/system/default.target
263     #dependency on a device unit fails it specially that we disabled udev
264     sed -i 's/After=dev-%i.device/After=/' ${rootfs_path}/lib/systemd/system/getty\@.service
265     chroot ${rootfs_path} chkconfig network on
266 }
267
268 function download_fedora() {
269 set -x
270     # check the mini fedora was not already downloaded
271     INSTALL_ROOT=$cache/partial
272     echo $INSTALL_ROOT
273     mkdir -p $INSTALL_ROOT
274     if [ $? -ne 0 ]; then
275         echo "Failed to create '$INSTALL_ROOT' directory"
276         return 1
277     fi
278
279     # download a mini fedora into a cache
280     echo "Downloading fedora minimal ..."
281     YUM="yum --installroot $INSTALL_ROOT -y --nogpgcheck --releasever=$release"
282     PKG_LIST="yum initscripts passwd rsyslog vim-minimal dhclient chkconfig rootfiles policycoreutils openssh-server openssh-clients"
283   
284     
285     MIRROR_URL=http://mirror.onelab.eu/fedora/releases/$release/Everything/$arch/os
286     RELEASE_URL1="$MIRROR_URL/Packages/fedora-release-$release-1.noarch.rpm"
287     # with fedora18 the rpms are scattered by first name
288     RELEASE_URL2="$MIRROR_URL/Packages/f/fedora-release-$release-1.noarch.rpm"
289     RELEASE_TARGET=$INSTALL_ROOT/fedora-release-$release.noarch.rpm
290     found=""
291     for attempt in $RELEASE_URL1 $RELEASE_URL2; do
292         if curl -f $attempt -o $RELEASE_TARGET ; then
293             echo "Retrieved $attempt"
294             found=true
295             break
296         else
297             echo "Failed attempt $attempt"
298     done
299     [ -n "$found" ] || { echo "Could not retrieve fedora-release rpm - exiting" ; exit 1; }
300     
301     mkdir -p $INSTALL_ROOT/var/lib/rpm
302     rpm --root $INSTALL_ROOT  --initdb
303     rpm --root $INSTALL_ROOT -ivh $INSTALL_ROOT/fedora-release-$release.noarch.rpm
304     echo "$YUM install $PKG_LIST"
305     $YUM install $PKG_LIST
306
307     if [ $? -ne 0 ]; then
308         echo "Failed to download the rootfs, aborting."
309         return 1
310     fi
311
312     mv "$INSTALL_ROOT" "$cache/rootfs"
313     echo "Download complete."
314
315     return 0
316 }
317
318
319 function copy_fedora() {
320 set -x
321     # make a local copy of the minifedora
322     echo -n "Copying rootfs to $rootfs_path ..."
323     mkdir -p $rootfs_path
324     rsync -a $cache/rootfs/ $rootfs_path/
325     return 0
326 }
327
328
329 function update_fedora() {
330 set -x
331     YUM="yum --installroot $cache/rootfs -y --nogpgcheck"
332     $YUM update
333 }
334
335
336 function install_fedora() {
337     set -x
338
339     mkdir -p /var/lock/subsys/
340     (
341         flock -n -x 200
342         if [ $? -ne 0 ]; then
343             echo "Cache repository is busy."
344             return 1
345         fi
346
347         echo "Checking cache download in $cache/rootfs ... "
348         if [ ! -e "$cache/rootfs" ]; then
349             download_fedora
350             if [ $? -ne 0 ]; then
351                 echo "Failed to download 'fedora base'"
352                 return 1
353             fi
354         else
355             echo "Cache found. Updating..."
356             update_fedora
357             if [ $? -ne 0 ]; then
358                 echo "Failed to update 'fedora base', continuing with last known good cache"
359             else
360                 echo "Update finished"
361             fi
362         fi
363
364         echo "Copy $cache/rootfs to $rootfs_path ... "
365         copy_fedora
366         if [ $? -ne 0 ]; then
367             echo "Failed to copy rootfs"
368             return 1
369         fi
370
371         return 0
372
373         ) 200>/var/lock/subsys/lxc
374
375     return $?
376 }
377
378
379 function copy_configuration() {
380
381     mkdir -p $config_path
382     cat <<EOF >> $config_path/config
383 lxc.utsname = $lxc
384 lxc.arch = $arch2
385 lxc.tty = 4
386 lxc.pts = 1024
387 lxc.rootfs = $rootfs_path
388 lxc.mount  = $config_path/fstab
389 #networking
390 lxc.network.type = $lxc_network_type
391 lxc.network.flags = up
392 lxc.network.link = $lxc_network_link
393 lxc.network.name = $IFNAME
394 lxc.network.mtu = 1500
395 lxc.network.ipv4 = $IP/$CIDR
396 lxc.network.veth.pair = $veth_pair
397 #cgroups
398 #lxc.cgroup.devices.deny = a
399 # /dev/null and zero
400 lxc.cgroup.devices.allow = c 1:3 rwm
401 lxc.cgroup.devices.allow = c 1:5 rwm
402 # consoles
403 lxc.cgroup.devices.allow = c 5:1 rwm
404 lxc.cgroup.devices.allow = c 5:0 rwm
405 lxc.cgroup.devices.allow = c 4:0 rwm
406 lxc.cgroup.devices.allow = c 4:1 rwm
407 # /dev/{,u}random
408 lxc.cgroup.devices.allow = c 1:9 rwm
409 lxc.cgroup.devices.allow = c 1:8 rwm
410 lxc.cgroup.devices.allow = c 136:* rwm
411 lxc.cgroup.devices.allow = c 5:2 rwm
412 # rtc
413 lxc.cgroup.devices.allow = c 254:0 rwm
414 lxc.cgroup.devices.allow = b 255:0 rwm
415 EOF
416
417
418
419     cat <<EOF > $config_path/fstab
420 proc            $rootfs_path/proc         proc    nodev,noexec,nosuid 0 0
421 devpts          $rootfs_path/dev/pts      devpts defaults 0 0
422 sysfs           $rootfs_path/sys          sysfs defaults  0 0
423 EOF
424     if [ $? -ne 0 ]; then
425         echo "Failed to add configuration"
426         return 1
427     fi
428
429     return 0
430 }
431
432
433
434
435 # overwrite lxc's internal yum config
436 function configure_yum_in_lxc () {
437     set -x 
438     set -e 
439     trap failure ERR INT
440
441     lxc=$1; shift
442     fcdistro=$1; shift
443     pldistro=$1; shift
444
445     echo "Initializing yum.repos.d in $lxc"
446     rm -f $rootfs_path/etc/yum.repos.d/*
447
448     cat > $rootfs_path/etc/yum.repos.d/building.repo <<EOF
449 [fedora]
450 name=Fedora $release - \$basearch
451 baseurl=http://mirror.onelab.eu/fedora/releases/$release/Everything/\$basearch/os/
452 enabled=1
453 metadata_expire=7d
454 gpgcheck=1
455 gpgkey=http://mirror.onelab.eu/keys/RPM-GPG-KEY-fedora-$release-primary
456
457 [updates]
458 name=Fedora $release - \$basearch - Updates
459 baseurl=http://mirror.onelab.eu/fedora/updates/$release/\$basearch/
460 enabled=1
461 metadata_expire=7d
462 gpgcheck=1
463 gpgkey=http://mirror.onelab.eu/keys/RPM-GPG-KEY-fedora-$release-primary
464 EOF
465     
466     # for using vtest-init-lxc.sh as a general-purpose lxc creation wrapper
467     # just mention 'none' as the repo url
468     if [ -n "$MYPLC_MODE" -a "$REPO_URL" != "none" ] ; then
469         if [ ! -d $rootfs_path/etc/yum.repos.d ] ; then
470             echo "WARNING : cannot create myplc repo"
471         else
472             # exclude kernel from fedora repos 
473             yumexclude=$(pl_plcyumexclude $fcdistro $pldistro $DIRNAME)
474             for repo in $rootfs_path/etc/yum.repos.d/* ; do
475                 [ -f $repo ] && yumconf_exclude $repo "exclude=$yumexclude" 
476             done
477             # the build repo is not signed at this stage
478             cat > $rootfs_path/etc/yum.repos.d/myplc.repo <<EOF
479 [myplc]
480 name= MyPLC
481 baseurl=$REPO_URL
482 enabled=1
483 gpgcheck=0
484 EOF
485         fi
486     fi
487 }    
488
489 # return yum or debootstrap
490 function package_method () {
491     fcdistro=$1; shift
492     case $fcdistro in
493         f[0-9]*|centos[0-9]*|sl[0-9]*) echo yum ;;
494         lenny|etch) echo debootstrap ;;
495         *) echo Unknown distro $fcdistro ;;
496     esac 
497 }
498
499 # return arch from debian distro and personality
500 function canonical_arch () {
501     personality=$1; shift
502     fcdistro=$1; shift
503     case $(package_method $fcdistro) in
504         yum)
505             case $personality in *32) echo i386 ;; *64) echo x86_64 ;; *) echo Unknown-arch-1 ;; esac ;;
506         debootstrap)
507             case $personality in *32) echo i386 ;; *64) echo amd64 ;; *) echo Unknown-arch-2 ;; esac ;;
508         *)
509             echo Unknown-arch-3 ;;
510     esac
511 }
512
513 # the new test framework creates /timestamp in /vservers/<name> *before* populating it
514 function almost_empty () { 
515     dir="$1"; shift ; 
516     # non existing is fine
517     [ ! -d $dir ] && return 0; 
518     # need to have at most one file
519     count=$(cd $dir; ls | wc -l); [ $count -le 1 ]; 
520 }
521
522 function setup_lxc() {
523
524     set -x
525     set -e
526     #trap failure ERR INT
527
528     lxc=$1; shift
529     fcdistro=$1; shift
530     pldistro=$1; shift
531     personality=$1; shift
532
533     # create lxc container 
534     copy_configuration
535     if [ $? -ne 0 ]; then
536         echo "failed write configuration file"
537         exit 1
538     fi
539
540     install_fedora
541     if [ $? -ne 0 ]; then
542         echo "failed to install fedora"
543         exit 1
544     fi
545
546     configure_fedora
547     if [ $? -ne 0 ]; then
548         echo "failed to configure fedora for a container"
549         exit 1
550     fi
551
552     type /bin/systemd >/dev/null 2>&1
553     if [ $? -ne 0 ]; then
554         configure_fedora_init
555     else
556         configure_fedora_systemd
557     fi
558
559     # Enable cgroup
560     mkdir $rootfs_path/cgroup
561     
562     # set up resolv.conf
563     cp /etc/resolv.conf $rootfs_path/etc/resolv.conf
564     # and /etc/hosts for at least localhost
565     [ -f $rootfs_path/etc/hosts ] || echo "127.0.0.1 localhost localhost.localdomain" > $rootfs_path/etc/hosts
566     
567     # ssh access to lxc
568     mkdir $rootfs_path/root/.ssh
569     cat /root/.ssh/id_rsa.pub >> $rootfs_path/root/.ssh/authorized_keys
570     
571     # start container
572     lxc-start -d -n $lxc
573
574     echo $IP is up, waiting for ssh...
575
576     # wait max 5 min for sshd to start 
577     ssh_up=""
578     stop_time=$(($(date +%s) + 300))
579     current_time=$(date +%s)
580
581     while [ "$current_time" -lt "$stop_time" ] ; do
582          echo "ssh attempt ..."
583          ssh -o "StrictHostKeyChecking no" $IP 'uname -i' && { ssh_up=true; echo "SSHD in container $lxc is UP"; break ; } || :
584          sleep 10
585          current_time=$(($current_time + 10))
586     done
587
588     [ -z $ssh_up ] && echo "SSHD in container $lxc is not running"
589      
590
591     # rpm --rebuilddb
592     chroot $rootfs_path rpm --rebuilddb
593     #ssh -o "StrictHostKeyChecking no" $IP "rpm --rebuilddb"
594
595     configure_yum_in_lxc $lxc $fcdistro $pldistro
596
597     return 0
598 }
599
600 function devel_or_vtest_tools () {
601
602     set -x 
603     set -e 
604     trap failure ERR INT
605
606     lxc=$1; shift
607     fcdistro=$1; shift
608     pldistro=$1; shift
609     personality=$1; shift
610
611     pkg_method=$(package_method $fcdistro)
612
613     # check for .pkgs file based on pldistro
614     if [ -n "$VBUILD_MODE" ] ; then
615         pkgsname=devel.pkgs
616     else
617         pkgsname=vtest.pkgs
618     fi
619     pkgsfile=$(pl_locateDistroFile $DIRNAME $pldistro $pkgsname)
620
621     ### install individual packages, then groups
622     # get target arch - use uname -i here (we want either x86_64 or i386)
623    
624     lxc_arch=$(chroot $rootfs_path uname -i)
625     # on debian systems we get arch through the 'arch' command
626     [ "$lxc_arch" = "unknown" ] && lxc_arch=$(chroot $rootfs_path arch)
627
628     packages=$(pl_getPackages -a $lxc_arch $fcdistro $pldistro $pkgsfile)
629     groups=$(pl_getGroups -a $lxc_arch $fcdistro $pldistro $pkgsfile)
630
631     case "$pkg_method" in
632         yum)
633             [ -n "$packages" ] && chroot $rootfs_path yum -y install $packages
634             for group_plus in $groups; do
635                 group=$(echo $group_plus | sed -e "s,+++, ,g")
636                 chroot $rootfs_path yum -y groupinstall "$group"
637             done
638             # store current rpm list in /init-lxc.rpms in case we need to check the contents
639             chroot $rootfs_path rpm -aq > $rootfs_path/init-lxc.rpms
640             ;;
641         debootstrap)
642             chroot $rootfs_path apt-get update
643             for package in $packages ; do 
644                 chroot $rootfs_path  apt-get install -y $package 
645             done
646             ### xxx todo install groups with apt..
647             ;;
648         *)
649             echo "unknown pkg_method $pkg_method"
650             ;;
651     esac
652
653     return 0
654 }
655
656 function post_install () {
657     if [ -n "$VBUILD_MODE" ] ; then
658         post_install_vbuild "$@" 
659     else
660         post_install_myplc "$@"
661     fi
662     # setup localtime from the host
663     lxc=$1; shift 
664     cp /etc/localtime $rootfs_path/etc/localtime
665 }
666
667 function post_install_vbuild () {
668
669     set -x 
670     set -e 
671     trap failure ERR INT
672
673     lxc=$1; shift
674     personality=$1; shift
675
676 ### From myplc-devel-native.spec
677 # be careful to backslash $ in this, otherwise it's the root context that's going to do the evaluation
678     cat << EOF | chroot $rootfs_path bash -x
679     # set up /dev/loop* in lxc
680     for i in \$(seq 0 255) ; do
681         mknod -m 640 /dev/loop\$i b 7 \$i
682     done
683     
684     # create symlink for /dev/fd
685     [ ! -e "/dev/fd" ] && ln -s /proc/self/fd /dev/fd
686
687     # modify /etc/rpm/macros to not use /sbin/new-kernel-pkg
688     sed -i 's,/sbin/new-kernel-pkg:,,' /etc/rpm/macros
689     if [ -h "/sbin/new-kernel-pkg" ] ; then
690         filename=\$(readlink -f /sbin/new-kernel-pkg)
691         if [ "\$filename" == "/sbin/true" ] ; then
692                 echo "WARNING: /sbin/new-kernel-pkg symlinked to /sbin/true"
693                 echo "\tmost likely /etc/rpm/macros has /sbin/new-kernel-pkg declared in _netsharedpath."
694                 echo "\tPlease remove /sbin/new-kernel-pkg from _netsharedpath and reintall mkinitrd."
695                 exit 1
696         fi
697     fi
698     
699     # customize root's prompt
700     cat << PROFILE > /root/.profile
701 export PS1="[$lxc] \\w # "
702 PROFILE
703
704     uid=2000
705     gid=2000
706     
707     # add a "build" user to the system
708     builduser=\$(grep "^build:" /etc/passwd | wc -l)
709     if [ \$builduser -eq 0 ] ; then
710         groupadd -o -g \$gid build;
711         useradd -o -c 'Automated Build' -u \$uid -g \$gid -n -M -s /bin/bash build;
712     fi
713
714 # Allow build user to build certain RPMs as root
715     if [ -f /etc/sudoers ] ; then
716         buildsudo=\$(grep "^build.*ALL=(ALL).*NOPASSWD:.*ALL"  /etc/sudoers | wc -l)
717         if [ \$buildsudo -eq 0 ] ; then
718             echo "build   ALL=(ALL)       NOPASSWD: ALL" >> /etc/sudoers
719         fi
720         sed -i 's,^Defaults.*requiretty,#Defaults requiretty,' /etc/sudoers
721     fi
722 #
723 EOF
724
725 }
726
727 function post_install_myplc  () {
728     set -x 
729     set -e 
730     trap failure ERR INT
731
732     lxc=$1; shift
733     personality=$1; shift
734
735 # be careful to backslash $ in this, otherwise it's the root context that's going to do the evaluation
736     cat << EOF | chroot $rootfs_path bash -x
737
738     # create /etc/sysconfig/network if missing
739     [ -f /etc/sysconfig/network ] || echo NETWORKING=yes > /etc/sysconfig/network
740
741     # create symlink for /dev/fd
742     [ ! -e "/dev/fd" ] && ln -s /proc/self/fd /dev/fd
743
744     # turn off regular crond, as plc invokes plc_crond
745     chkconfig crond off
746
747     # take care of loginuid in /etc/pam.d 
748     sed -i "s,#*\(.*loginuid.*\),#\1," /etc/pam.d/*
749
750     # customize root's prompt
751     cat << PROFILE > /root/.profile
752 export PS1="[$lxc] \\w # "
753 PROFILE
754
755 EOF
756 }
757
758 function usage () {
759     set +x 
760     echo "Usage: $COMMAND_VBUILD [options] lxc-name"
761     echo "Usage: $COMMAND_MYPLC [options] lxc-name repo-url [ -- lxc-options ]"
762     echo "Description:"
763     echo "   This command creates a fresh lxc instance, for building, or running, myplc"
764     echo "Supported options"
765     echo " -f fcdistro - for creating the root filesystem - defaults to $DEFAULT_FCDISTRO"
766     echo " -d pldistro - defaults to $DEFAULT_PLDISTRO"
767     echo " -p personality - defaults to $DEFAULT_PERSONALITY"
768     echo " -i ifname: determines ip and netmask attached to ifname, and passes it to the lxc"
769     echo "-- lxc-options"
770     echo "  --netdev : interface to be defined inside lxc"
771     echo "  --interface : IP to be defined for the lxc"
772     echo "  --hostname : Hostname to be defined for the lxc"
773     echo "With $COMMAND_MYPLC you can give 'none' as the URL, in which case"
774     echo "   myplc.repo does not get created"
775     exit 1
776 }
777
778 ### parse args and 
779 function main () {
780
781     #set -e
782     #trap failure ERR INT
783
784     case "$COMMAND" in
785         $COMMAND_VBUILD)
786             VBUILD_MODE=true ;;
787         $COMMAND_MYPLC)
788             MYPLC_MODE=true;;
789         *)
790             usage ;;
791     esac
792
793     VERBOSE=
794     RESISTANT=""
795     IFNAME=""
796     LXC_OPTIONS=""
797     while getopts "f:d:p:i:" opt ; do
798         case $opt in
799             f) fcdistro=$OPTARG;;
800             d) pldistro=$OPTARG;;
801             p) personality=$OPTARG;;
802             i) IFNAME=$OPTARG;;
803             *) usage ;;
804         esac
805     done
806         
807     shift $(($OPTIND - 1))
808
809     # parse fixed arguments
810     [[ -z "$@" ]] && usage
811     lxc=$1 ; shift
812     if [ -n "$MYPLC_MODE" ] ; then
813         [[ -z "$@" ]] && usage
814         REPO_URL=$1 ; shift
815     fi
816
817     # parse vserver options
818     if [[ -n "$@" ]] ; then
819         if [ "$1" == "--" ] ; then
820             shift
821             LXC_OPTIONS="$@"
822         else
823             usage
824         fi
825     fi
826
827     eval set -- "$LXC_OPTIONS"
828
829     while true
830      do
831         case "$1" in
832              --netdev)      IFNAME=$2; shift 2;;
833              --interface)   IP=$2; shift 2;;
834              --hostname)    HOSTNAME=$2; shift 2;;
835              *)             break ;;
836         esac
837       done
838
839    
840     if [ -n "$VBUILD_MODE" ] ; then
841         [ -z "$IFNAME" ] && IFNAME=$DEFAULT_IFNAME
842         [ -z "$HOSTNAME" ] && HOSTNAME=$lxc
843     fi
844
845     [ -z "$fcdistro" ] && fcdistro=$DEFAULT_FCDISTRO
846     [ -z "$pldistro" ] && pldistro=$DEFAULT_PLDISTRO
847     [ -z "$personality" ] && personality=$DEFAULT_PERSONALITY
848     
849     release=$(echo $fcdistro | cut -df -f2)
850
851     if [ "$personality" == "linux32" ]; then
852         arch=i386
853         arch2=x86
854     elif [ "$personality" == "linux64" ]; then
855         arch=x86_64
856         arch2=x86_64
857     else
858         echo "Unknown personality: $personality"
859     fi
860
861     # need lxc installed before we can run lxc-ls
862     # need bridge installed
863     prepare_host    
864
865     if [ -n "$VBUILD_MODE" ] ; then
866
867         # Bridge IP affectation
868         x=$(echo $personality | cut -dx -f2)
869         y=$(echo $fcdistro | cut -df -f2)
870         z=$(($x + $y))
871
872         IP="192.168.122.$z"
873         NETMASK="255.255.255.0"
874         GATEWAY="192.168.122.1"
875         
876         lxc_network_type=veth
877         lxc_network_link=virbr0
878         veth_pair="veth$z"
879         echo "the IP address of container $lxc is $IP "
880     else
881         [[ -z "$REPO_URL" ]] && usage
882         [[ -z "$IP" ]] && usage
883         NETMASK=$(ifconfig br0 | grep 'inet addr' | awk '{print $4}' | sed -e 's/.*://')
884         GATEWAY=$(route -n | grep 'UG' | awk '{print $2}')
885         [[ -z "$HOSTNAME" ]] && usage
886         lxc_network_type=veth
887         lxc_network_link=br0
888         veth_pair="i$(echo $HOSTNAME | cut -d. -f1)"
889     fi
890
891     CIDR=$(cidr_notation $NETMASK)
892     
893
894     if [ "$(id -u)" != "0" ]; then
895           echo "This script should be run as 'root'"
896           exit 1
897     fi
898
899     path=/var/lib/lxc
900     rootfs_path=$path/$lxc/rootfs
901     config_path=$path/$lxc
902     cache_base=/var/cache/lxc/fedora/$arch
903     cache=$cache_base/$release
904     root_password=root
905     
906     # check whether the rootfs directory is created to know if the container exists
907     # bacause /var/lib/lxc/$lxc is already created while putting $lxc.timestamp
908     [ -d $rootfs_path ] && { echo "container $lxc already exists - exiting" ; exit 1 ; }
909
910     setup_lxc $lxc $fcdistro $pldistro $personality 
911
912     devel_or_vtest_tools $lxc $fcdistro $pldistro $personality
913
914     post_install $lxc $personality
915     
916
917     echo $COMMAND Done
918 }
919
920 main "$@"